import React, { PropTypes } from 'react'
import styled, { css } from 'styled-components'

const parseProps = ({ overflow, style, ...props }) => {
  const newStyles = {}

  newStyles.overflow = overflow

  return { style: { ...newStyles, ...style }, ...props }
}

const withOverflow = (Comp) => {
  const HoComp = (props) =>
    React.createElement(Comp, parseProps(props))

  HoComp.propTypes = {
    ...Comp.propTypes,
    overflow: PropTypes.oneOf([
      'hidden',
      'visible',
      'scroll',
      'auto',
      'inherit',
      'initial'
    ])
  }

  HoComp.displayName = Comp.displayName

  return HoComp
}

export {
  withOverflow
}
